=== debian/changelog ===
dsda-doom (0.29.4+dfsg-2) unstable; urgency=medium

  * Build-Depend on dh-sequence-bash-completion
  * Pass the canonical path to the build arch toolchain file

 -- Fabian Greffrath <fabian@debian.org>  Tue, 30 Sep 2025 15:30:50 +0200

dsda-doom (0.29.4+dfsg-1) unstable; urgency=medium

  * Bump debian/watch file to version 5
  * New upstream version 0.29.4+dfsg
  * Replace Build-Depends on libdumb1-dev with libxmp-dev for the MOD
    music backend
  * Bump Build-Depends to libfluidsynth-dev (>> 2.4.3+dfsg-4~) and
    libzip-dev (>> 1.11.3-2~) and drop the utility packages that these
    now depend on
  * Use a build arch toolchain file for the rdatawad utility, instead
    of running a native build
  * Let the upstream rules install the icon and desktop file
  * Remove reduntant RRR: no field

 -- Fabian Greffrath <fabian@debian.org>  Tue, 30 Sep 2025 08:48:22 +0200
