=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

TOOLCHAIN_FILE = $(shell readlink -f debian/toolchain)

%:
	dh $@ \
		--sourcedirectory=prboom2

override_dh_auto_configure:
	$(SHELL) /usr/share/cmake/debtoolchainfilegen $(DEB_BUILD_ARCH) > $(TOOLCHAIN_FILE)
	dh_auto_configure -- \
		-DCMAKE_INSTALL_BINDIR=games \
		-DDSDAPWADDIR=/usr/share/dsda-doom \
		-DDSDA_HOST_TOOLCHAIN=$(TOOLCHAIN_FILE)

override_dh_installchangelogs:
	dh_installchangelogs -- patch_notes/v$(basename $(DEB_VERSION_UPSTREAM))*

override_dh_gencontrol:
	dh_gencontrol -pprboom-plus             -- -v3:$(DEB_VERSION_UPSTREAM_REVISION)
	dh_gencontrol -pprboom-plus-game-server -- -v3:$(DEB_VERSION_UPSTREAM_REVISION)
	dh_gencontrol --remaining-packages

execute_after_dh_install:
	find debian/ -name 'COPYING*' -delete
