=== debian/watch ===
Version: 5
Source: https://github.com/kraflab/@PACKAGE@/tags
Matching-Pattern: https://github.com/kraflab/@PACKAGE@/archive/refs/tags/v@ANY_VERSION@@ARCHIVE_EXT@
Dversion-Mangle: s/@DEB_EXT@//
Repack-Suffix: +dfsg
Compression: xz
